// PluginDialog.cpp : implementation file
//

#include "stdafx.h"
#include "TestPlugin.h"
#include "PluginDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CFont* boldfont;
/////////////////////////////////////////////////////////////////////////////
// CPluginDialog dialog


CPluginDialog::CPluginDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CPluginDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPluginDialog)
	//}}AFX_DATA_INIT
	boldfont = NULL;
}


void CPluginDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPluginDialog)
	DDX_Control(pDX, IDC_MAINLAB, m_cMainLabel);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPluginDialog, CDialog)
	//{{AFX_MSG_MAP(CPluginDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPluginDialog message handlers

typedef HRESULT (__stdcall *PFNSETWINDOWTHEME)(HWND hwnd, LPCWSTR pszSubAppName, LPCWSTR pszSubIdList );


CFont* boldfont; //bold font for main plugin title
CPluginDialog dlg;
BOOL bPauseAllBackroundActivity;


///////////////////////////////////////////////////////////////
void CreatePP(POINT pt, HWND* pWnd)
{
	
	ASSERT(*pWnd);

	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	dlg.Create(IDD_DIALOG1);
	dlg.ShowWindow(SW_SHOWNORMAL);
	
	dlg.ModifyStyle(WS_POPUP, WS_CHILD); //let's remove WS_POPUP style and add WS_CHILD
	::SetParent(dlg.m_hWnd, *pWnd); //set parent for our window to main window of Tray Helper
	dlg.SetWindowPos(NULL,0,0,0,0,SWP_NOSIZE|SWP_NOZORDER); //move our window to left top corner of window of Tray Helper (0,0)
	
	//Tray Helper has some error messages that are displayed when plugin is failed to create it's own window
	//here we get HWND to those 3 static controls and hide them !
	HWND hwndErrorControl = ::GetDlgItem(*pWnd, 1029);
	if(::IsWindow(hwndErrorControl))
	{
		::ShowWindow(hwndErrorControl, SW_HIDE);
	}
	
	hwndErrorControl = ::GetDlgItem(*pWnd, 1030);
	if(::IsWindow(hwndErrorControl))
	{
		::ShowWindow(hwndErrorControl, SW_HIDE);
	}
	
	hwndErrorControl = ::GetDlgItem(*pWnd, 1369);
	if(::IsWindow(hwndErrorControl))
	{
		::ShowWindow(hwndErrorControl, SW_HIDE);
	}

	//Under windows XP - near all dialogs of Tray Helper use Windows XP visual styles (themes)
	//But main windows of tabs has those themes disabled (it just looks better that way).
	//Since your window is now a child of main Tray Helper window it will inherit a "property sheet" theme.
	//It's recommended to disable this theme. You have to do this in a way that will still works on Window 95 and 98
	//This code does the job and is fully portable (will work on old windows either).
	HINSTANCE m_hDll = ::LoadLibrary(_T("UxTheme.dll"));
	PFNSETWINDOWTHEME pfnSetWindowTheme = (PFNSETWINDOWTHEME)GetProcAddress(m_hDll, "SetWindowTheme");
	if(pfnSetWindowTheme != NULL)
	{
		(*pfnSetWindowTheme)(dlg.m_hWnd,NULL,L"");
	}
	FreeLibrary(m_hDll);
	
}

//Fired when window was moved - ignored in most cases
void OnMovePP(POINT pt)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
}

//Fired when window was restored - ignored in most cases
void OnSetActivatePP(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
}

//Fired when window was hidded - ignored in most cases
void OnKillActivatePP(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
}

const char* OnGetYourNamePP(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return "TEST PLUGIN 1";
}

void OnSizePP(int cx, int cy)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	if(dlg)
		dlg.SetWindowPos(NULL,0,0,cx,cy,SWP_NOZORDER|SWP_NOMOVE);
}

HICON OnGetYourIconPP(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	return AfxGetApp()->LoadIcon(IDI_PLUGIN);
}
//if name of this plugin is in Langyage file - please specify line number - enter 0 if name of this plugin is not in language file
int OnGetYourName_LineInTxtFile(void)
{
	return 0;
}

//if SHORT name of this plugin is in Langyage file - please specify line number - enter 0 if name of this plugin is not in language file
int OnGetYourShortName_LineInTxtFile(void)
{
	return 0;
}

//enter here version of plugin
float OnGetYour_Version(void)
{
	return (float)1.0;
}

void OnStartYourBackgroundActivityPP(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	//start background threads here main window can be not created yet
}

void OnPauseAllBackgroundActivityPP(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	bPauseAllBackroundActivity = TRUE;
}


void OnResumeAllBackgroundActivityPP(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	bPauseAllBackroundActivity = FALSE;
}

//good place to do clean-up. Close all worker threads (if any), free memory ect...
//after this call plugin can be unloaded from memofy using FreeLibrary API
void OnExitPP(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
}

//for future usage - ignore this
LPVOID DoSomething_1PP(LPVOID lpParam)
{
	return NULL;
}

//for future usage - ignore this
LPVOID DoSomething_2PP(LPVOID lpParam)
{
	return NULL;
}

//for future usage - ignore this
LPVOID DoSomething_3PP(LPVOID lpParam)
{
	return NULL;
}



///////////////////////////////////////////////////////////////


BOOL CPluginDialog::OnInitDialog() 
{
	
	CDialog::OnInitDialog();
	
	boldfont = new CFont;
	boldfont->CreateFont(25,0,0,0,900,0,0,0,0,0,0,ANTIALIASED_QUALITY,0,"Arial CE");

	m_cMainLabel.SetFont(boldfont);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

CPluginDialog::~CPluginDialog()
{
	delete boldfont;
}
